#include <Adafruit_NeoPixel.h>
#include <Servo.h>

Adafruit_NeoPixel pixels(16, 4, NEO_GRB + NEO_KHZ800); // (numberofpixels, arduino pin [...])

Servo servo_L;
Servo servo_R;
Servo servo_W;

float i = 0.05;
float l = 10;
float r = 10;
float w = 180;

int pin_button_G = 9;
int pin_button_Y = 10;
int pin_button_R = 11;

void setup()
{
  pinMode(A0, INPUT);
  digitalWrite(A0, HIGH);

  pinMode(9, INPUT);
  digitalWrite(9, HIGH);
  pinMode(10, INPUT);
  digitalWrite(10, HIGH);
  pinMode(11, INPUT);
  digitalWrite(11, HIGH);

  pixels.begin();

  startUp();

  servo_L.attach(7, 500, 2500);
  servo_L.writeMicroseconds(map(10, 0, 360, 500, 2500));

  servo_R.attach(6, 500, 2500);
  servo_R.writeMicroseconds(map(10, 0, 360, 500, 2500));

  servo_W.attach(5, 500, 2500);
  servo_W.writeMicroseconds(map(180, 0, 360, 500, 2500));
}

void loop()
{
  if (digitalRead(pin_button_G) == LOW) // GREEN BUTTON
  {
    i = 0.05;
    for (int p = 10; p > -1; p--)
    { pixels.setPixelColor(p, pixels.Color(0, 127, 0));
      pixels.show();
      delay(25);
    }

    for (int p = 16; p > 10; p--)
    { pixels.setPixelColor(p, pixels.Color(0, 127, 0));
      pixels.show();
      delay(25);
    }
  }

  if (digitalRead(pin_button_Y) == LOW) // YELLOW BUTTON
  {
    i = 0.10;
    for (int p = 10; p > -1; p--)
    { pixels.setPixelColor(p, pixels.Color(223, 63, 0));
      pixels.show();
      delay(25);
    }

    for (int p = 16; p > 10; p--)
    { pixels.setPixelColor(p, pixels.Color(223, 63, 0));
      pixels.show();
      delay(25);
    }
  }

  if (digitalRead(pin_button_R) == LOW) // RED BUTTON
  {
    i = 0.15;
    for (int p = 10; p > -1; p--)
    { pixels.setPixelColor(p, pixels.Color(255, 0, 0));
      pixels.show();
      delay(25);
    }

    for (int p = 16; p > 10; p--)
    { pixels.setPixelColor(p, pixels.Color(255, 0, 0));
      pixels.show();
      delay(25);
    }
  }

  if (digitalRead(A0) == LOW) // JOYSTICK BUTTON
  {
    w = 180;
  }

  if (analogRead(A1) <= 127)
  {
    w -= i;
  }

  if (analogRead(A1) >= 895)
  {
    w += i;
  }

  if (analogRead(A2) <= 127)
  {
    l += i;
    r += i;
  }

  if (analogRead(A2) >= 895)
  {
    l -= i;
    r -= i;
  }

  if (w < 45) w = 45;  if (w > 315) w = 315;
  servo_W.writeMicroseconds(map(w, 0, 360, 500, 2500));

  if (l < 10) l = 10;  if (l > 170) l = 170;
  servo_L.writeMicroseconds(map(l, 0, 360, 500, 2500));

  if (r < 10) r = 10;  if (r > 170) r = 170;
  servo_R.writeMicroseconds(map(r, 0, 360, 500, 2500));
}

void startUp()
{
  for (int p = 10; p > -1; p--)
  { pixels.setPixelColor(p, pixels.Color(127, 127, 127));
    pixels.show();
    delay(50);
  }

  for (int p = 16; p > 10; p--)
  { pixels.setPixelColor(p, pixels.Color(127, 127, 127));
    pixels.show();
    delay(50);
  }

  for (int p = 10; p > -1; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 0, 0));
    pixels.show();
    delay(50);
  }

  for (int p = 16; p > 10; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 0, 0));
    pixels.show();
    delay(50);
  }

  for (int p = 10; p > -1; p--)
  { pixels.setPixelColor(p, pixels.Color(127, 127, 127));
    pixels.show();
    delay(50);
  }

  for (int p = 16; p > 10; p--)
  { pixels.setPixelColor(p, pixels.Color(127, 127, 127));
    pixels.show();
    delay(50);
  }

  for (int p = 10; p > -1; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 0, 0));
    pixels.show();
    delay(50);
  }

  for (int p = 16; p > 10; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 0, 0));
    pixels.show();
    delay(50);
  }

  for (int p = 10; p > -1; p--)
  { pixels.setPixelColor(p, pixels.Color(127, 127, 127));
    pixels.show();
    delay(50);
  }

  for (int p = 16; p > 10; p--)
  { pixels.setPixelColor(p, pixels.Color(127, 127, 127));
    pixels.show();
    delay(50);
  }


/***
  for (int p = 10; p > -1; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 0, 0));
    pixels.show();
    delay(50);
  }

  for (int p = 16; p > 10; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 0, 0));
    pixels.show();
    delay(50);
  }

  for (int p = 10; p > -1; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 127, 0));
    pixels.show();
    delay(50);
  }

  for (int p = 16; p > 10; p--)
  { pixels.setPixelColor(p, pixels.Color(0, 127, 0));
    pixels.show();
    delay(50);
  }
***/
}
